All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
PASNGauge Class Reference

A descendant of PASNObject which is an unsigned ASN guage type. More...

`#include <pasn.h>`

Inheritance diagram for PASNGauge:

## Public Member Functions

| PASNGauge (PASNUnsigned val)
| PASNGauge (const PBYTEArray &buffer, PINDEX &ptr)
PBoolean | Decode (const PBYTEArray &buffer, PINDEX &i)
void | Encode (PBYTEArray &buffer)
| Virtual function used to encode the object into ASN format. More...
PObject * | Clone () const
| Virtual function used to duplicate objects. More...
PASNObject::ASNType | GetType () const
| Return a value of type enum ASNType which indicates the type of the object. More...
PString | GetTypeAsString () const
| Return a string giving the type of the object. More...
Public Member Functions inherited from PASNUnsignedInteger
| PASNUnsignedInteger (PASNUnsigned val)
| PASNUnsignedInteger (const PBYTEArray &buffer, PINDEX &ptr)
void | PrintOn (ostream &strm) const
| Virtual functions used by the PObject::operator<< function to print the value of the object. More...
WORD | GetEncodedLength ()
| Virtual function used to get the length of object when encoded into ASN format. More...
PString | GetString () const
| Return the value of the object as a PString. More...
PASNUnsigned | GetUnsigned () const
| Return the value of the object as a PASNUnsigned. More...
Public Member Functions inherited from PASNObject
int | GetChoice () const
| Return the descriminator for Choice sequences. More...
virtual PASNInt | GetInteger () const
| Return the value of the ASN object as a PASNInt. More...
virtual const PASNSequence & | GetSequence () const
| Return the value of the object as a PString. More...
virtual PIPSocket::Address | GetIPAddress () const
| Return the value of the object as an IPAddress. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Additional Inherited Members

Public Types inherited from PASNObject
enum | ASNType { Integer, String, ObjectID, Sequence, Choice, IPAddress, Counter, Gauge, TimeTicks, Opaque, NsapAddress, Counter64, UInteger32, Null, Unknown, ASNTypeMax }
| Value returned by the GetType() function to indicate the type of an ASN object. More...
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PASNObject
static void | EncodeASNLength (PBYTEArray &buffer, WORD length)
| Encode an ASN length value. More...
static WORD | GetASNLengthLength (WORD length)
| Return the length of an encoded ASN length value. More...
static PBoolean | DecodeASNLength (const PBYTEArray &buffer, PINDEX &ptr, WORD &len)
| Decode an ASN length in the buffer at the given ptr. More...
static void | EncodeASNSequenceStart (PBYTEArray &buffer, BYTE type, WORD length)
| Encode a sequence header into the buffer at the specified offset. More...
static WORD | GetASNSequenceStartLength (WORD length)
| Return the encoded length of a sequence if it has the specified length. More...
static void | EncodeASNHeader (PBYTEArray &buffer, PASNObject::ASNType type, WORD length)
| Encode an ASN object header into the buffer. More...
static WORD | GetASNHeaderLength (WORD length)
| Return the length of an ASN object header if the object is the specified length. More...
static void | EncodeASNInteger (PBYTEArray &buffer, PASNInt data, PASNObject::ASNType type)
static void | EncodeASNUnsigned (PBYTEArray &buffer, PASNUnsigned data, PASNObject::ASNType type)
static WORD | GetASNIntegerLength (PASNInt data)
static WORD | GetASNUnsignedLength (PASNUnsigned data)
static PBoolean | DecodeASNInteger (const PBYTEArray &buffer, PINDEX &ptr, PASNInt &value, ASNType type=Integer)
static PBoolean | DecodeASNUnsigned (const PBYTEArray &buffer, PINDEX &ptr, PASNUnsigned &value, ASNType type=TimeTicks)
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
Protected Member Functions inherited from PASNUnsignedInteger
| PASNUnsignedInteger ()
PBoolean | Decode (const PBYTEArray &buffer, PINDEX &i, PASNObject::ASNType theType)
void | Encode (PBYTEArray &buffer, PASNObject::ASNType theType)
Protected Member Functions inherited from PASNObject
| PASNObject ()
| Create an empty ASN object. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Static Protected Attributes inherited from PASNObject
static BYTE | ASNTypeToType [ASNTypeMax]
| Table to map enum ASNType values to ASN identifiers. More...

## Detailed Description

A descendant of PASNObject which is an unsigned ASN guage type.

## Constructor & Destructor Documentation

PASNGauge::PASNGauge | ( | PASNUnsigned | val | ) |

inline

Referenced by Clone().

PASNGauge::PASNGauge | ( | const PBYTEArray & | buffer,
|  | PINDEX & | ptr
| ) |  |

inline

References Decode().

## Member Function Documentation

PObject* PASNGauge::Clone | ( |  | ) | const

inline virtual

Virtual function used to duplicate objects.

Reimplemented from PASNObject.

References PASNGauge(), and PNEW.

PBoolean PASNGauge::Decode | ( | const PBYTEArray & | buffer,
|  | PINDEX & | i
| ) |  |

inline

References PASNUnsignedInteger::Decode(), and PASNObject::Gauge.

Referenced by PASNGauge().

void PASNGauge::Encode | ( | PBYTEArray & | buffer | ) |

inline virtual

Virtual function used to encode the object into ASN format.

Reimplemented from PASNObject.

References PASNUnsignedInteger::Encode(), and PASNObject::Gauge.

PASNObject::ASNType PASNGauge::GetType | ( |  | ) | const

inline virtual

Return a value of type enum ASNType which indicates the type of the object.

Reimplemented from PASNObject.

References PASNObject::Gauge.

PString PASNGauge::GetTypeAsString | ( |  | ) | const

virtual

Return a string giving the type of the object.

Reimplemented from PASNObject.

The documentation for this class was generated from the following file:

- pasn.h